package it.unitn.molerat.data.printers;

import it.unitn.molerat.evidence.VulnerabilityEvidence;

import java.util.*;

public class VulnerabilityEvidencePrinter {

    private final StringBuilder builder = new StringBuilder();

    public VulnerabilityEvidencePrinter(Set<VulnerabilityEvidence> evidence) {
        List<VulnerabilityEvidence> sortedEvidence = new LinkedList<>(evidence);
        Collections.sort(sortedEvidence, new Comparator<VulnerabilityEvidence>() {
            @Override
            public int compare(VulnerabilityEvidence o1, VulnerabilityEvidence o2) {
                if (o1.getLineNumber() < o2.getLineNumber()) {
                    return -1;
                } else if (o1.getLineNumber() > o2.getLineNumber()) {
                    return 1;
                } else {
                    return 0;
                }
            }
        });

        String path = "";
        String container = "";
        for (VulnerabilityEvidence e : sortedEvidence) {
           if (!path.equals(e.getPath()))  {
              path = e.getPath();
              builder.append("<" + path + ">\n");
           }
           if (!container.equals(e.getContainer())) {
               container = e.getContainer();
               builder.append("\t" + container + "\n");
           }
           builder.append("\t\t" + e.getLineNumber() + ": " + e.getLineContents() + "\n");
        }
    }

    @Override
    public String toString() {
        return this.builder.toString();
    }

}
