package it.unitn.molerat.evidence;

public class VulnerabilityEvidence extends GenericEvidence {

    protected final int lineNumber;
    protected final String lineContents;

    public VulnerabilityEvidence(String file, String commit, String container, int lineNumber, String lineContents) {
		super(file, commit, container);
        this.lineNumber = lineNumber;
        this.lineContents = lineContents
                            .trim()
                            .replace("\t","");
    }

    public int getLineNumber() {
        return this.lineNumber;
    }

    public String getLineContents() {
        return this.lineContents;
    }

    @Override
    public String toString() {
        StringBuilder builder = new StringBuilder();
		builder.append("<" + commit + ": " + path + ">\n");
		builder.append("\t" + container + "\n");
		builder.append("\t\t" + lineNumber + ": " + lineContents + "\n\t\n");
        return builder.toString();
    }
}
